import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Bouncer here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bouncer extends Actor
{
    private double exactX;
    private double exactY;
    int angle = 0;
    double power = 0;
    double vSpeed = 0;
    double grav = 0;
    
    /**
     * Test if we are close to one of the edges of the world. Return true if we are.
     */
    public boolean atWorldEdge()
    {
        if(getX() < 5 || getX() > getWorld().getWidth() - 5)
            return true;
        if(getY() < 5 || getY() > getWorld().getHeight() - 5)
            return true;
        else
            return false;
    }
    
    public double getPower()
    {
        return power;
    }
    
    public void setPower(double p)
    {
        power=p;
    }
    
    public void setGravity(double g)
    {
        grav = g;
    }
    
    public void fall()
    {
        if(getY() > getWorld().getHeight() - getImage().getHeight()/2 && grav>0){
            if(getY() > getWorld().getHeight() - getImage().getHeight()/2 + 1)
                setLocation(getX(), getY()-1);
            if(power>=grav)
                power-=grav;
            vSpeed = 0;
        }
        if((getY() <= getWorld().getHeight() - getImage().getHeight()/2 && grav>0)||(getY() >= getImage().getHeight()/2 && grav<0)){
            setLocation(getX(), getY()+vSpeed);
            vSpeed+=grav;
        }
        if(getY() < getImage().getHeight()/2 && grav<0){
            if(getY() < getImage().getHeight()/2 - 1)
                setLocation(getX(), getY()+1);
            if(power>=grav)
                power+=grav;
            vSpeed = 0;
        }
    }
    
    public void fall(Class clss)
    {
        Actor obj = getOneIntersectingObject(clss);
        if(obj!=null && grav>0){
            if(power>=grav)
                power-=grav;
            else if(obj!=null&&(getY()<obj.getY()||vSpeed>0)){
                if(getY()<obj.getY()&&(canSee(clss, 0, getImage().getHeight()/2+1)||canSee(clss, getImage().getWidth()/2, getImage().getHeight()/2+1)||canSee(clss, -getImage().getWidth()/2, getImage().getHeight()/2+1))){
                    bounce(clss);
                    setLocation(getX(), getY()-power);
                }
                power+=1;
            }
            vSpeed = 0;
        }
        if(obj!=null && grav<0){
            if(power>=grav)
                power+=grav;
            else if(obj!=null&&(getY()<obj.getY()||vSpeed>0)){
                if(getY()>obj.getY()&&(canSee(clss, 0, -getImage().getHeight()/2-1)||canSee(clss, getImage().getWidth()/2, -getImage().getHeight()/2-1)||canSee(clss, -getImage().getWidth()/2, -getImage().getHeight()/2-1))){
                    bounce(clss);
                    setLocation(getX(), getY()+power);
                }
                power+=1;
            }
            vSpeed = 0;
        }
    }
    
    public void move(int distance)
    {
        move((double)distance);
    }
    
    /**
     * Move forward by the specified exact distance.
     */
    public void move(double distance)
    {
        double radians = Math.toRadians(angle);
        double dx = Math.cos(radians) * distance;
        double dy = Math.sin(radians) * distance;
        setLocation(exactX + dx, exactY + dy);
    }
    
    /**
     * Return true if we can see an object of class 'clss' right where we are. 
     * False if there is no such object here.
     */
    public boolean canSee(Class clss, int dx, int dy)
    {
        Actor actor = getOneObjectAtOffset(dx, dy, clss);
        return actor != null;        
    }

    public boolean canTouch(Class clss)
    {
        if(canSee(clss, getImage().getWidth()/2/9, getImage().getHeight()/2/9) || canSee(clss, -getImage().getWidth()/2/9, -getImage().getHeight()/2/9) || canSee(clss, -getImage().getWidth()/2/9, getImage().getHeight()/2/9) || canSee(clss, getImage().getWidth()/2/9, -getImage().getHeight()/2/9))
        {
            return true;
        }else{
            return false;
        }
    }
    
    public void bounce(Class clss) 
    {
        if(canSee(clss, getImage().getWidth()/2/2, 0) || canSee(clss, -getImage().getWidth()/2/2, 0) || canSee(clss, 0, getImage().getHeight()/2/2) || canSee(clss, 0, -getImage().getHeight()/2/2)){
            if(canSee(clss, getImage().getWidth()/2/2, 0) || canSee(clss, -getImage().getWidth()/2/2, 0)){
                setAngle(getAngle() + (180-getAngle()*2));
                if(getAngle()==0 || getAngle()==90 || getAngle()==180 || getAngle()==270)
                {
                    if(Greenfoot.getRandomNumber(2)==0)
                    {
                        //setAngle(getAngle()+30);
                    }else{
                        //setAngle(getAngle()-30);
                    }
                }
            }
            if(canSee(clss, 0, getImage().getHeight()/2/2) || canSee(clss, 0, -getImage().getHeight()/2/2)){
                setAngle(360-getAngle());
                if(getAngle()==0 || getAngle()==90 || getAngle()==180 || getAngle()==270)
                {
                    if(Greenfoot.getRandomNumber(2)==0)
                    {
                        //setAngle(getAngle()+30);
                    }else{
                        //setAngle(getAngle()-30);
                    }
                }
            }
            move(2);
        }
    } 
    
    public void bounce() 
    {
        if(atWorldEdge()){
            if(getX() < getImage().getHeight()/2 || getX() > getWorld().getWidth() - getImage().getWidth()/2){
                setAngle(getAngle() + (180-getAngle()*2));
                if(getAngle()==0 || getAngle()==90 || getAngle()==180 || getAngle()==270)
                {
                    if(Greenfoot.getRandomNumber(2)==0)
                    {
                        //setAngle(getAngle()+30);
                    }else{
                        //setAngle(getAngle()-30);
                    }
                }
            }
            if(getY() < getImage().getWidth()/2 || getY() > getWorld().getHeight() - getImage().getHeight()/2){
                setAngle(360-getAngle());
                if(getAngle()==0 || getAngle()==90 || getAngle()==180 || getAngle()==270)
                {
                    if(Greenfoot.getRandomNumber(2)==0)
                    {
                        //setAngle(getAngle()+30);
                    }else{
                        //setAngle(getAngle()-30);
                    }
                }
            }
            move(2);
        }
    }
    
    public void setAngle(int a)
    {
        angle = a;
    }
    
    public int getAngle()
    {
        return angle;
    }
    
    /**
     * Set the location using exact coordinates.
     */
    public void setLocation(double x, double y) 
    {
        exactX = x;
        exactY = y;
        super.setLocation((int) (x + 0.5), (int) (y + 0.5));
    }
    
    /**
     * Set the location using integer coordinates.
     * (Overrides the method in Actor.)
     */
    @Override
    public void setLocation(int x, int y) 
    {
        exactX = x;
        exactY = y;
        super.setLocation(x, y);
    }
}
